Package org.eclipse.m2m.atl.core

# Class ModelFactory

java.lang.Object
org.eclipse.m2m.atl.core.ModelFactory

Direct Known Subclasses:
  `ASMFactory`, `EMFModelFactory`

public abstract class ModelFactory extends Object
The ModelFactory abstract class allows to create `IModel` and `IReferenceModel`.

## Constructor Summary

Constructors
Constructor
Description
`ModelFactory()`

## Method Summary

Modifier and Type
Method
Description
`abstract IReferenceModel`
`getBuiltInResource(String name)`
Returns the built-in resource matching the given name.
`abstract String`
`getDefaultExtractorName()`
Returns a default `IExtractor` associated with the current factory.
`abstract String`
`getDefaultInjectorName()`
Returns a default `IInjector` associated with the current factory.
`abstract IReferenceModel`
`getMetametamodel()`
Returns the Metametamodel.
`abstract IModel`
`newModel(IReferenceModel referenceModel)`
Creates a new `IModel` using default options and conforming to the given `IReferenceModel`.
`abstract IModel`
`newModel(IReferenceModel referenceModel, Map<String,Object> options)`
Creates a new `IModel` using specified options and conforming to the given `IReferenceModel`.
`abstract IReferenceModel`
`newReferenceModel()`
Creates a new `IReferenceModel` using default options.
`abstract IReferenceModel`
`newReferenceModel(Map<String,Object> options)`
Creates a new `IReferenceModel` using specified options.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ModelFactory

public ModelFactory()

## Method Details

### getMetametamodel

public abstract IReferenceModel getMetametamodel()
Returns the Metametamodel.

Returns:
  the Metametamodel

### getDefaultInjectorName

public abstract String getDefaultInjectorName()
Returns a default `IInjector` associated with the current factory.

Returns:
  the default `IInjector`

### getDefaultExtractorName

public abstract String getDefaultExtractorName()
Returns a default `IExtractor` associated with the current factory.

Returns:
  the default `IExtractor`

### newReferenceModel

public abstract IReferenceModel newReferenceModel() throws ATLCoreException
Creates a new `IReferenceModel` using default options.

Returns:
  a new `IReferenceModel`
Throws:
  `ATLCoreException`

### newReferenceModel

public abstract IReferenceModel newReferenceModel(Map<String,Object> options) throws ATLCoreException
Creates a new `IReferenceModel` using specified options.

Parameters:
  `options` - the creation options
Returns:
  a new `IReferenceModel`
Throws:
  `ATLCoreException`

### newModel

public abstract IModel newModel(IReferenceModel referenceModel) throws ATLCoreException
Creates a new `IModel` using default options and conforming to the given `IReferenceModel`.

Parameters:
  `referenceModel` - the `IReferenceModel`
Returns:
  a new `IModel`
Throws:
  `ATLCoreException`

### newModel

public abstract IModel newModel(IReferenceModel referenceModel, Map<String,Object> options) throws ATLCoreException
Creates a new `IModel` using specified options and conforming to the given `IReferenceModel`.

Parameters:
  `referenceModel` - the `IReferenceModel`
  `options` - the creation options
Returns:
  a new `IModel`
Throws:
  `ATLCoreException`

### getBuiltInResource

public abstract IReferenceModel getBuiltInResource(String name) throws ATLCoreException
Returns the built-in resource matching the given name.

Parameters:
  `name` - the resource name
Returns:
  the built-in resource matching the given name
Throws:
  `ATLCoreException`